***** REPETITIOUS CODE;

TITLE 'DATA SET LABS';

PROC CONTENTS DATA=LABS;
RUN;

PROC PRINT DATA=LABS (OBS=5);
RUN;


***** EXAMPLE1;

%LET DSN=LABS;

TITLE "DATA SET &DSN";

PROC CONTENTS DATA=&DSN;
RUN;

PROC PRINT DATA=&DSN (OBS=10);

RUN;


***** CHANGE THE DATA SET NAME;

%LET DSN=HOSPITAL;

TITLE "DATA SET &DSN";

PROC CONTENTS DATA=&DSN;
RUN;

PROC PRINT DATA=&DSN (OBS=10);
RUN;

***** EXAMPLE 2;

%LET AGE4=%STR(

IF AGE < 20 THEN GROUP = '<20  ';
ELSE
IF AGE < 35 THEN GROUP = '20-34';
ELSE
IF AGE < 45 THEN GROUP = '35-44';
ELSE             GROUP = '45+';

);

%LET AGE2=%STR(

IF AGE <35 THEN GROUP = '<35';
ELSE            GROUP = '35+';

);

***** USE THE MACRO TEXT IN A DATA STEP;

OPTIONS SYMBOLGEN;
DATA TEST;
INPUT AGE @@;
&AGE2;
DATALINES;
19 50 10 34 44 15 30
;
RUN;

TITLE 'DATA SET TEST';
PROC PRINT DATA=TEST;
RUN;

***** ALTERNATIVE TO SYMBOLGEN;

%PUT &AGE2;

***** EXAMPLE 3;

DATA TEST;
INPUT X @@;
PUT 'THE VALUE OF X IS:  ' X;
%PUT TODAY IS &SYSDATE;
%PUT 'THE VALUE OF X IS:  ' X;
DATALINES;
1 2 3
;
RUN;

TITLE 'DATA SET TEST';
PROC PRINT DATA=TEST;
RUN;

*****  HOW MANY LINES ARE WRITTEN TO THE LOG FILE VIA PUT AND %PUT?;

/*
    1ST       SYNTAX CHECK/COMPILE

    2ND       EXECUTION

    MACRO STATEMENTS ARE EXECUTED FIRST

    1ST       MACRO STATEMENTS

    2ND       SYNTAX CHECK/COMPILE

    3RD       EXECUTION


PUT CAN BE USED WITH SAS-SUPPLIED NAMES...

         PUT _NUMERIC_;

         PUT _CHARACTER_;

         PUT _ALL_;

%PUT CAN BE USED WITH SAS-SUPPLIED NAMES...

         %PUT _ALL_;

         %PUT _AUTOMATIC_:
              SAS-SUPPLIED MACRO VARIABLES (SUCH AS &SYSDATE)

         %PUT _USER_;
              USER-DEFINED MACRO VARIABLES

         %PUT _LOCAL_;
         %PUT _GLOBAL_;

*/

***** EXAMPLE 4;

DATA ALL;
INPUT GENDER : $1. @@;
CARDS;
M F M F M F M M M
;
RUN;

%LET GENDER=M;

DATA JUST_&GENDER;
SET ALL;
WHERE GENDER EQ "&GENDER";
RUN;

***** EXAMPLE 5;

%LET MONTH=JAN;
%LET YEAR=96;

DATA &MONTH&YEAR (KEEP=X Y Z);
INFILE "F:\19&YEAR\ALL_&YEAR..DAT";
INPUT (MON X Y Z) ($3. 3*3.);
IF MON EQ "&MONTH";
RUN;

TITLE "DATA SET &MONTH&YEAR";
PROC PRINT DATA=&MONTH&YEAR;
RUN;


***** EXAMPLE 6;

%LET YR=96;
DATA DATA&YR.M
     DATA&YR.F;
SET ALL (WHERE=(YEAR EQ "19&YR"));
IF GENDER EQ 'M' THEN   OUTPUT DATA&YR.M;
ELSE                    OUTPUT DATA&YR.F;
RUN;


***** EXAMPLE 7;

%MACRO AGE4;
    IF AGE < 20 THEN GROUP = '<20  ';
    ELSE
    IF AGE < 35 THEN GROUP = '20-34';
    ELSE
    IF AGE < 45 THEN GROUP = '35-44';
    ELSE             GROUP = '45+';
%MEND;
%MACRO AGE2;
    IF AGE <35 THEN GROUP = '<35';
    ELSE            GROUP = '35+';
%MEND;


OPTIONS MPRINT;

DATA TEST;
INPUT AGE @@;
%AGE2;
DATALINES;
19 50 10 34 44 15 30
;
RUN;

PROC PRINT DATA=TEST;
RUN;


***** EXAMPLE 8;

%MACRO AGE_EDIT(GROUPS);
   %IF &GROUPS EQ 4 %THEN %DO;
         IF AGE < 20 THEN GROUP = '<20  ';
         ELSE
         IF AGE < 35 THEN GROUP = '20-34';
         ELSE
         IF AGE < 45 THEN GROUP = '35-44';
         ELSE             GROUP = '45+';
   %END;
   %ELSE %DO;
         IF AGE <35 THEN GROUP = '<35';
         ELSE            GROUP = '35+';
   %END;
%MEND;

OPTION MPRINT;
DATA TEST;
INPUT AGE @@;
%AGE_EDIT(4);
DATALINES;
19 50 10 34 44 15 30
;
RUN;

PROC PRINT DATA=TEST;
RUN;

***** EXAMPLE 9;

%MACRO AGE_EDIT(GROUPS=4);
   %IF &GROUPS EQ 4 %THEN %DO;
         IF AGE < 20 THEN GROUP = '<20  ';
         ELSE
         IF AGE < 35 THEN GROUP = '20-34';
         ELSE
         IF AGE < 45 THEN GROUP = '35-44';
         ELSE             GROUP = '45+';
   %END;
   %ELSE %DO;
         IF AGE <35 THEN GROUP = '<35';
         ELSE            GROUP = '35+';
   %END;
%MEND;

DATA TEST;
INPUT AGE @@;
%AGE_EDIT;
DATALINES;
19 50 10 34 44 15 30
;
RUN;

***** EXAMPLE 10;

%MACRO PRINTIT(DSN=LABS,NOBSERV=5);
TITLE "DATA SET &DSN";
PROC CONTENTS DATA=&DSN;
RUN;
PROC PRINT DATA=&DSN (OBS=&NOBSERV);
RUN;
%MEND;

%PRINTIT;


***** EXAMPLE 11;

%MACRO PRINTIT(DSN,FIRST,HOWMANY);
%LET LASTOBS=%EVAL(&FIRST+&HOWMANY-1);
TITLE "DATA SET &DSN";
PROC PRINT DATA=&DSN (FIRSTOBS=&FIRST OBS=&LASTOBS);
RUN;
%MEND;

DATA LAB;
INPUT X @@;
DATALINES;
888 348 38 216 47 5552 4563 6544 45 336 722 81 2223 3444 999
;
RUN;

OPTIONS MPRINT;
%PRINTIT(LAB,6,5);

***** EXAMPLE 12;

DATA MYDATA;
INPUT X @@;
DATALINES;
11 22 33 44 55 66 77 88 99 100 110 22
;
RUN;

DATA _NULL_;
CALL SYMPUT('OBSERV',NUMOBS);
STOP;
SET MYDATA NOBS=NUMOBS;
RUN;

TITLE "FIRST 3 OF &OBSERV OBSERVATIONS IN DATA SET MYDATA";
PROC PRINT DATA=MYDATA (OBS=3);
RUN;

DATA _NULL_;
CALL SYMPUT('OBSERVX',trim(left(put(NUMOBS,best.))));
STOP;
SET MYDATA NOBS=NUMOBS;
RUN;

TITLE "FIRST 3 OF &OBSERVX OBSERVATIONS IN DATA SET MYDATA";
PROC PRINT DATA=MYDATA (OBS=3);
RUN;